=== modified file 'storage/myisam/mf_keycaches.cc'
--- storage/myisam/mf_keycaches.cc	2009-03-21 20:32:38 +0000
+++ storage/myisam/mf_keycaches.cc	2009-03-22 00:20:27 +0000
@@ -68,9 +68,10 @@
   This function is called by the hash object on delete
 */
 
-static void safe_hash_entry_free(SAFE_HASH_ENTRY *entry)
+extern "C"
+void safe_hash_entry_free(void *entry)
 {
-  free((unsigned char*) entry);
+  free(entry);
   return;
 }
 
@@ -109,7 +110,7 @@
 {
   if (hash_init(&hash->hash, &my_charset_bin, elements,
 		0, 0, (hash_get_key) safe_hash_entry_get,
-		(void (*)(void*)) safe_hash_entry_free, 0))
+		safe_hash_entry_free, 0))
   {
     hash->default_value= 0;
     return(1);

=== modified file 'storage/myisam/mi_check.cc'
--- storage/myisam/mi_check.cc	2009-03-21 20:32:38 +0000
+++ storage/myisam/mi_check.cc	2009-03-22 00:20:27 +0000
@@ -67,16 +67,19 @@
 static int writekeys(MI_SORT_PARAM *sort_param);
 static int sort_one_index(MI_CHECK *param, MI_INFO *info,MI_KEYDEF *keyinfo,
 			  my_off_t pagepos, File new_file);
-static int sort_key_read(MI_SORT_PARAM *sort_param,void *key);
-static int sort_get_next_record(MI_SORT_PARAM *sort_param);
-static int sort_key_cmp(MI_SORT_PARAM *sort_param, const void *a,const void *b);
-static int sort_key_write(MI_SORT_PARAM *sort_param, const void *a);
-static my_off_t get_record_for_key(MI_INFO *info,MI_KEYDEF *keyinfo,
-				unsigned char *key);
-static int sort_insert_key(MI_SORT_PARAM  *sort_param,
-                           register SORT_KEY_BLOCKS *key_block,
-			   unsigned char *key, my_off_t prev_block);
-static int sort_delete_record(MI_SORT_PARAM *sort_param);
+extern "C"
+{
+  int sort_key_read(MI_SORT_PARAM *sort_param,void *key);
+  int sort_get_next_record(MI_SORT_PARAM *sort_param);
+  int sort_key_cmp(MI_SORT_PARAM *sort_param, const void *a,const void *b);
+  int sort_key_write(MI_SORT_PARAM *sort_param, const void *a);
+  my_off_t get_record_for_key(MI_INFO *info,MI_KEYDEF *keyinfo,
+                              unsigned char *key);
+  int sort_insert_key(MI_SORT_PARAM  *sort_param,
+                      register SORT_KEY_BLOCKS *key_block,
+                      unsigned char *key, my_off_t prev_block);
+  int sort_delete_record(MI_SORT_PARAM *sort_param);
+}
 /*static int flush_pending_blocks(MI_CHECK *param);*/
 static SORT_KEY_BLOCKS	*alloc_key_blocks(MI_CHECK *param, uint32_t blocks,
 					  uint32_t buffer_length);
@@ -2867,7 +2870,7 @@
 
 	/* Read next record and return next key */
 
-static int sort_key_read(MI_SORT_PARAM *sort_param, void *key)
+int sort_key_read(MI_SORT_PARAM *sort_param, void *key)
 {
   int error;
   SORT_INFO *sort_info=sort_param->sort_info;
@@ -2925,7 +2928,7 @@
     > 0         error
 */
 
-static int sort_get_next_record(MI_SORT_PARAM *sort_param)
+int sort_get_next_record(MI_SORT_PARAM *sort_param)
 {
   int searching;
   int parallel_flag;
@@ -3392,8 +3395,7 @@
 
 	/* Compare two keys from _create_index_by_sort */
 
-static int sort_key_cmp(MI_SORT_PARAM *sort_param, const void *a,
-			const void *b)
+int sort_key_cmp(MI_SORT_PARAM *sort_param, const void *a, const void *b)
 {
   uint32_t not_used[2];
   return (ha_key_cmp(sort_param->seg, *((unsigned char* const *) a), *((unsigned char* const *) b),
@@ -3401,7 +3403,7 @@
 } /* sort_key_cmp */
 
 
-static int sort_key_write(MI_SORT_PARAM *sort_param, const void *a)
+int sort_key_write(MI_SORT_PARAM *sort_param, const void *a)
 {
   uint32_t diff_pos[2];
   char llbuff[22],llbuff2[22];
@@ -3458,18 +3460,17 @@
 
 	/* get pointer to record from a key */
 
-static my_off_t get_record_for_key(MI_INFO *info, MI_KEYDEF *keyinfo,
-				   unsigned char *key)
-{
+my_off_t get_record_for_key(MI_INFO *info, MI_KEYDEF *keyinfo,
+                            unsigned char *key) {
   return _mi_dpos(info,0,key+_mi_keylength(keyinfo,key));
 } /* get_record_for_key */
 
 
 	/* Insert a key in sort-key-blocks */
 
-static int sort_insert_key(MI_SORT_PARAM *sort_param,
-			   register SORT_KEY_BLOCKS *key_block, unsigned char *key,
-			   my_off_t prev_block)
+int sort_insert_key(MI_SORT_PARAM *sort_param,
+                    register SORT_KEY_BLOCKS *key_block, unsigned char *key,
+                    my_off_t prev_block)
 {
   uint32_t a_length,t_length,nod_flag;
   my_off_t filepos,key_file_length;
@@ -3549,7 +3550,7 @@
 
 	/* Delete record when we found a duplicated key */
 
-static int sort_delete_record(MI_SORT_PARAM *sort_param)
+int sort_delete_record(MI_SORT_PARAM *sort_param)
 {
   uint32_t i;
   int old_file,error;

=== modified file 'storage/myisam/mi_create.cc'
--- storage/myisam/mi_create.cc	2009-03-21 22:20:58 +0000
+++ storage/myisam/mi_create.cc	2009-03-22 00:20:27 +0000
@@ -490,13 +490,13 @@
   */
   if (ci->index_file_name)
   {
-    char *iext= strrchr(ci->index_file_name, '.');
+    char *iext= strrchr((char *)ci->index_file_name, '.');
     int have_iext= iext && !strcmp(iext, MI_NAME_IEXT);
     if (options & HA_OPTION_TMP_TABLE)
     {
       char *path;
       /* chop off the table name, tempory tables use generated name */
-      if ((path= strrchr(ci->index_file_name, FN_LIBCHAR)))
+      if ((path= strrchr((char *)ci->index_file_name, FN_LIBCHAR)))
         *path= '\0';
       fn_format(filename, name, ci->index_file_name, MI_NAME_IEXT,
                 MY_REPLACE_DIR | MY_UNPACK_FILENAME |
@@ -519,7 +519,7 @@
   }
   else
   {
-    char *iext= strrchr(name, '.');
+    char *iext= strrchr((char *)name, '.');
     int have_iext= iext && !strcmp(iext, MI_NAME_IEXT);
     fn_format(filename, name, "", MI_NAME_IEXT,
               MY_UNPACK_FILENAME | MY_RETURN_REAL_PATH |
@@ -558,14 +558,14 @@
     {
       if (ci->data_file_name)
       {
-        char *dext= strrchr(ci->data_file_name, '.');
+        char *dext= strrchr((char *)ci->data_file_name, '.');
         int have_dext= dext && !strcmp(dext, MI_NAME_DEXT);
 
         if (options & HA_OPTION_TMP_TABLE)
         {
           char *path;
           /* chop off the table name, tempory tables use generated name */
-          if ((path= strrchr(ci->data_file_name, FN_LIBCHAR)))
+          if ((path= strrchr((char *)ci->data_file_name, FN_LIBCHAR)))
             *path= '\0';
           fn_format(filename, name, ci->data_file_name, MI_NAME_DEXT,
                     MY_REPLACE_DIR | MY_UNPACK_FILENAME | MY_APPEND_EXT);

=== modified file 'storage/myisam/sort.cc'
--- storage/myisam/sort.cc	2009-03-21 22:20:58 +0000
+++ storage/myisam/sort.cc	2009-03-22 00:20:27 +0000
@@ -42,43 +42,45 @@
 
 /* Functions defined in this file */
 
-static ha_rows  find_all_keys(MI_SORT_PARAM *info,uint32_t keys,
+extern "C" 
+{
+ha_rows  find_all_keys(MI_SORT_PARAM *info,uint32_t keys,
 			      unsigned char **sort_keys,
 			      DYNAMIC_ARRAY *buffpek,
 			      size_t *maxbuffer,
 			      IO_CACHE *tempfile,
 			      IO_CACHE *tempfile_for_exceptions);
-static int  write_keys(MI_SORT_PARAM *info,unsigned char **sort_keys,
+int  write_keys(MI_SORT_PARAM *info,unsigned char **sort_keys,
                              uint32_t count, BUFFPEK *buffpek,IO_CACHE *tempfile);
-static int  write_key(MI_SORT_PARAM *info, unsigned char *key,
+int  write_key(MI_SORT_PARAM *info, unsigned char *key,
 			    IO_CACHE *tempfile);
-static int  write_index(MI_SORT_PARAM *info,unsigned char * *sort_keys,
+int  write_index(MI_SORT_PARAM *info,unsigned char * *sort_keys,
                               uint32_t count);
-static int  merge_many_buff(MI_SORT_PARAM *info,uint32_t keys,
+int  merge_many_buff(MI_SORT_PARAM *info,uint32_t keys,
 			    unsigned char * *sort_keys,
 			    BUFFPEK *buffpek,size_t *maxbuffer,
 			    IO_CACHE *t_file);
-static uint32_t  read_to_buffer(IO_CACHE *fromfile,BUFFPEK *buffpek,
+uint32_t  read_to_buffer(IO_CACHE *fromfile,BUFFPEK *buffpek,
                                   uint32_t sort_length);
-static int  merge_buffers(MI_SORT_PARAM *info,uint32_t keys,
+int  merge_buffers(MI_SORT_PARAM *info,uint32_t keys,
                                 IO_CACHE *from_file, IO_CACHE *to_file,
                                 unsigned char * *sort_keys, BUFFPEK *lastbuff,
                                 BUFFPEK *Fb, BUFFPEK *Tb);
-static int  merge_index(MI_SORT_PARAM *,uint,unsigned char **,BUFFPEK *, int,
+int  merge_index(MI_SORT_PARAM *,uint,unsigned char **,BUFFPEK *, int,
                               IO_CACHE *);
-
-static int  write_keys_varlen(MI_SORT_PARAM *info,unsigned char **sort_keys,
-                                    uint32_t count, BUFFPEK *buffpek,
-                                    IO_CACHE *tempfile);
-static uint32_t  read_to_buffer_varlen(IO_CACHE *fromfile,BUFFPEK *buffpek,
-                                         uint32_t sort_length);
-static int  write_merge_key(MI_SORT_PARAM *info, IO_CACHE *to_file,
-                                  unsigned char *key, uint32_t sort_length, uint32_t count);
-static int  write_merge_key_varlen(MI_SORT_PARAM *info,
-					 IO_CACHE *to_file,
-					 unsigned char* key, uint32_t sort_length,
-					 uint32_t count);
-static inline int
+int  write_keys_varlen(MI_SORT_PARAM *info,unsigned char **sort_keys,
+                       uint32_t count, BUFFPEK *buffpek,
+                       IO_CACHE *tempfile);
+uint32_t  read_to_buffer_varlen(IO_CACHE *fromfile,BUFFPEK *buffpek,
+                                uint32_t sort_length);
+int  write_merge_key(MI_SORT_PARAM *info, IO_CACHE *to_file,
+                     unsigned char *key, uint32_t sort_length, uint32_t count);
+int  write_merge_key_varlen(MI_SORT_PARAM *info,
+                            IO_CACHE *to_file,
+                            unsigned char* key, uint32_t sort_length,
+                            uint32_t count);
+}
+inline int
 my_var_write(MI_SORT_PARAM *info, IO_CACHE *to_file, unsigned char *bufs);
 
 /*
@@ -248,7 +250,7 @@
 
 /* Search after all keys and place them in a temp. file */
 
-static ha_rows  find_all_keys(MI_SORT_PARAM *info, uint32_t keys,
+ha_rows  find_all_keys(MI_SORT_PARAM *info, uint32_t keys,
 			      unsigned char **sort_keys,
 			      DYNAMIC_ARRAY *buffpek,
 			      size_t *maxbuffer, IO_CACHE *tempfile,
@@ -623,7 +625,7 @@
 
         /* Write all keys in memory to file for later merge */
 
-static int  write_keys(MI_SORT_PARAM *info, register unsigned char **sort_keys,
+int  write_keys(MI_SORT_PARAM *info, register unsigned char **sort_keys,
                              uint32_t count, BUFFPEK *buffpek, IO_CACHE *tempfile)
 {
   unsigned char **end;
@@ -648,7 +650,7 @@
 } /* write_keys */
 
 
-static inline int
+inline int
 my_var_write(MI_SORT_PARAM *info, IO_CACHE *to_file, unsigned char *bufs)
 {
   int err;
@@ -663,7 +665,7 @@
 }
 
 
-static int  write_keys_varlen(MI_SORT_PARAM *info,
+int  write_keys_varlen(MI_SORT_PARAM *info,
 				    register unsigned char **sort_keys,
                                     uint32_t count, BUFFPEK *buffpek,
 				    IO_CACHE *tempfile)
@@ -689,7 +691,7 @@
 } /* write_keys_varlen */
 
 
-static int  write_key(MI_SORT_PARAM *info, unsigned char *key,
+int  write_key(MI_SORT_PARAM *info, unsigned char *key,
 			    IO_CACHE *tempfile)
 {
   uint32_t key_length=info->real_key_length;
@@ -708,7 +710,7 @@
 
 /* Write index */
 
-static int  write_index(MI_SORT_PARAM *info, register unsigned char **sort_keys,
+int  write_index(MI_SORT_PARAM *info, register unsigned char **sort_keys,
                               register uint32_t count)
 {
   my_qsort2((unsigned char*) sort_keys,(size_t) count,sizeof(unsigned char*),
@@ -724,7 +726,7 @@
 
         /* Merge buffers to make < MERGEBUFF2 buffers */
 
-static int  merge_many_buff(MI_SORT_PARAM *info, uint32_t keys,
+int  merge_many_buff(MI_SORT_PARAM *info, uint32_t keys,
 			    unsigned char **sort_keys, BUFFPEK *buffpek,
 			    size_t *maxbuffer, IO_CACHE *t_file)
 {
@@ -781,7 +783,7 @@
     -1	Error
 */
 
-static uint32_t  read_to_buffer(IO_CACHE *fromfile, BUFFPEK *buffpek,
+uint32_t  read_to_buffer(IO_CACHE *fromfile, BUFFPEK *buffpek,
                                   uint32_t sort_length)
 {
   register uint32_t count;
@@ -800,7 +802,7 @@
   return (count*sort_length);
 } /* read_to_buffer */
 
-static uint32_t  read_to_buffer_varlen(IO_CACHE *fromfile, BUFFPEK *buffpek,
+uint32_t  read_to_buffer_varlen(IO_CACHE *fromfile, BUFFPEK *buffpek,
                                          uint32_t sort_length)
 {
   register uint32_t count;
@@ -832,7 +834,7 @@
 } /* read_to_buffer_varlen */
 
 
-static int  write_merge_key_varlen(MI_SORT_PARAM *info,
+int  write_merge_key_varlen(MI_SORT_PARAM *info,
 					 IO_CACHE *to_file, unsigned char* key,
                                          uint32_t sort_length, uint32_t count)
 {
@@ -850,7 +852,7 @@
 }
 
 
-static int  write_merge_key(MI_SORT_PARAM *info,
+int  write_merge_key(MI_SORT_PARAM *info,
 				  IO_CACHE *to_file, unsigned char *key,
 				  uint32_t sort_length, uint32_t count)
 {
@@ -863,7 +865,7 @@
   If to_file == 0 then use info->key_write
 */
 
-static int
+int
 merge_buffers(MI_SORT_PARAM *info, uint32_t keys, IO_CACHE *from_file,
               IO_CACHE *to_file, unsigned char **sort_keys, BUFFPEK *lastbuff,
               BUFFPEK *Fb, BUFFPEK *Tb)
@@ -1006,7 +1008,7 @@
 
         /* Do a merge to output-file (save only positions) */
 
-static int
+int
 merge_index(MI_SORT_PARAM *info, uint32_t keys, unsigned char **sort_keys,
             BUFFPEK *buffpek, int maxbuffer, IO_CACHE *tempfile)
 {

